#include "jserver.h"

#define PHASE_INIT 0
#define PHASE_LOGIN 1
#define PHASE_PRE 2
#define PHASE_NORM 3

#define APHASE_REG_GET 0
#define APHASE_REG_SET 1

#define ROOM "#jabber"
#define PINGER 120

typedef struct fields_struct
{
    pool p;
    char *name;
    char *data;
    struct fields_struct *prev,*next;
} _fields,*fields;

/* our 'session' data */
typedef struct ircdata_struct
{
    int phase, initflag, whoflag, debug;
    /* for agent support */
    int agent_phase;
    fields agent_fields;
    fields next_field;
    char *key;
    char *agent_jid;
    /* ***************** */
    char *nick;
    char *server;
    char *pass;
    char *res;
    char *lastnick;
    char *buffer;
    session s;
    jid id;
    thread t;
    xmlnode roster;
    ppdb pres;
    struct ircdata_struct *prev, *next;
} *ircdata, _ircdata;

void svc_irc_line(ircdata d, char *from, char *cmd, char *data, int argc, ...);
void svc_irc_in(session s, jpacket p, void *arg);
void svc_irc_out(ircdata d, char *cmd, char *from, char **args);

xmlnode svc_irc_item(ircdata d, jid id);
char *svc_irc_nick(ircdata d, jid id);
char *svc_irc_id(ircdata d, char *nick);

void svc_irc_who(ircdata d, char *to);
